const $http = (url, data, type, loadingType) => {
  var app = getApp()
  // 判断token是否有或者过期
  //轮询接口专用判断
  // if(loadingType != 'NO'){
  //   dd.showLoading({
  //     content: '加载中...'
  //   });
  // }
  // dd.showLoading({content: '加载中...'});
  let hasToken = dd.getStorageSync({ key: 'token' }).data; // token
  let expires_in = hasToken.expires_in || ''; // 过期时效
  let loginTime = hasToken.loginTime || ''; // 用户登陆时间
  let token = hasToken.access_token || '';
  let refresh_token = hasToken.refresh_token // 刷新token
  let mingUserId = dd.getStorageSync({ key: 'mingUserId' }).data
  // 时间戳未过期
  if(!!hasToken && ((new Date()).getTime() - hasToken.loginTime)< (hasToken.expires_in-300) * 1000){
    data.orgId = dd.corpId;
    let sendData = '';
    for(let key in data){
      sendData = `${sendData}${key}=${data[key]}&`
    }
    sendData = sendData.substring(0, sendData.length - 1);
    return new Promise((resolve, reject) => {
      dd.httpRequest({
        headers: {
          "Content-Type": "application/json",
          "Authorization": `Bearer ${token}`
        },
        url: `${app.globalData.globalUrl}/mingpay-phone/v1/${url}?${sendData}`,
        method: type,
        dataType: 'json',
        success: function(res) {
          if(res.data.resultCode === 0) {
            console.log(res.data.data)
            return resolve(res.data.data)
            dd.hideLoading()
          }
          else if(res.data.code == 401) {
            dd.removeStorageSync({key: 'token'})
            dd.hideLoading()
            dd.redirectTo({
              url: '/pages/reTry/reTry'
            })
          }
          else {
            //  修改系统繁忙时loading隐藏
            dd.hideLoading();
            dd.alert({
              content: '请检查网络并下拉重试',
              buttonText: '确定'
            });
          }
        },
        fail: function(err) {
          // 服务端没有token
          if(err.status == 401 ) {
            dd.httpRequest({
              headers: {
                'Authorization': 'Basic bWluZ3BheS1waG9uZTptaW5ncGF5LXBob25l',
                'Content-Type': 'application/x-www-form-urlencoded'
              },
              data: {
               grant_type: 'refresh_token',
               refresh_token: refresh_token
              },
              url:`${app.globalData.globalUrl}/auth/oauth/token`,
              method: 'POST',
              dataType: 'json',
              success: function(res) {
                dd.setStorageSync({
                  key: 'token',
                  data: {
                    access_token: res.data.access_token,
                    expires_in: res.data.expires_in,
                    refresh_token: res.data.refresh_token,
                    loginTime: (new Date()).getTime()
                  }
                })
                dd.hideLoading()
                $http(url, data, type).then(res => {
                  return resolve(res)
                })
              },
              fail: function(err) {
                dd.hideLoading()
                if(err.status == 426) {
                dd.removeStorageSync({key: 'token'})
                dd.redirectTo({
                  url: '/pages/reTry/reTry'
                })
                }
                else {
                  dd.alert({
                    content:'请检查网络并下拉重试',
                    buttonText: '确定'
                  })
                }
              }
            })
          }
          else {
            dd.alert({
              content:'请检查网络并下拉重试',
              buttonText: '确定'
            })
            dd.hideLoading();
          }
        }
      })
    })
  } 
  // 时间戳过期
  else {
    return new Promise((resolve,reject) => {
      dd.getNetworkType({
        success: (res) => {
        // 有网的情况下
        if (res.networkAvailable) {
          dd.httpRequest({
             headers: {
               'Authorization': 'Basic bWluZ3BheS1waG9uZTptaW5ncGF5LXBob25l',
               'Content-Type': 'application/x-www-form-urlencoded'
             },
             dataType: 'json',
             data: {
               grant_type: 'refresh_token',
               refresh_token: refresh_token
             },
             url:`${app.globalData.globalUrl}/auth/oauth/token`,
             method: 'POST',
             success: function(res) {
               dd.removeStorageSync({
                 key:'token'
               })
               dd.setStorageSync({
                 key: 'token',
                 data: {
                   access_token: res.data.access_token,
                   expires_in: res.data.expires_in,
                   refresh_token: res.data.refresh_token,
                   loginTime: (new Date()).getTime()
                 }
               })
               dd.hideLoading()
               $http(url, data, type).then(res => {
                 return resolve(res)
               })
             },
             fail: function(err) {
               if(err.status == 426) {
                 dd.hideLoading()
                 dd.removeStorageSync({
                    key:'token'
                  })
                 dd.redirectTo({
                   url: '/pages/reTry/reTry'
                 })
               }
               else {
                  dd.alert({
                    content:'请检查网络并下拉重试',
                    buttonText: '确定'
                  })
                  dd.hideLoading();
                }
              }
            })
        } 
        else {
          dd.alert({
            content: '请检查网络并下拉重试',
            buttonText: '确定'
          });
          dd.hideLoading()
        }
      }
     
    });

    })
  
  }
}
export default {$http}